//Fragment Shader
#version 330 core
//in worldNormal;
in vec2 fUVs;

layout(location = 0) out vec4 FragColor;
layout(location = 1) out vec4 BrightColor;

uniform sampler2D uColorTexture;
uniform bool uBrightness = false;
 
void main()
{
	FragColor = texture(uColorTexture, fUVs);

	if (uBrightness)
	{
		float brightness = dot(FragColor.rgb, vec3(0.2126, 0.7152, 0.0722));
		if (brightness > 1.)
			BrightColor = vec4(FragColor.rgb, 1.0);
		else
			BrightColor = vec4(0.);
	}
	BrightColor = vec4(0.f);

}