//Vertex Shader
#version 330 core

in vec3 aNormal, aPosition;
in vec2 aUV;

out vec3 eyePosition, worldNormal;
out vec2 fUVs;

out vec3  PointLightPosition1, DirectionalLightDirection1;

out vec4 DirLightSpacePos;

//uniform vec3 PointLightPosition1, DirectionalLightDirection1;
uniform vec3 DirectionalLightDirection;
uniform mat4 uProjection, uView, uModel=mat4(1.f);
uniform mat4 dirLightProj, dirLightView;

uniform mat4 uOldProjView, uInvProjView, uCur2OldModel;

void main()
{
	PointLightPosition1 = (uView * vec4(2.4f, 3.7f, -5.54817f, 1.0f)).xyz;
	DirectionalLightDirection1 = normalize((uView * vec4(DirectionalLightDirection, 0.0f)).xyz);

	mat4 L = mat4(0.5f);
	L[3] = vec4(0.5f, 0.5f, 0.5f, 1.0f);
	DirLightSpacePos = L * dirLightProj * dirLightView * uModel * vec4(aPosition, 1.0);


	fUVs = aUV;
	eyePosition = (uView * uModel * vec4(aPosition, 1.f)).xyz;
	mat3 scale = transpose(mat3(uModel))*mat3(uModel);
	vec3 Normal;
	for (int i = 0; i < 3; ++i)
		Normal[i] = 1/(scale[i][i])*aNormal[i];
	worldNormal = normalize((uView * uModel * vec4(Normal, 0.0f)).xyz);

	gl_Position = uProjection * vec4(eyePosition, 1.f);

	//gl_Position = vec4(aPosition, 1.0f);
}
