//Vertex Shader
#version 330 core

in vec3 aPosition;
in vec2 aUV;

out vec4 pixPosition;
out mat4 new2old;


uniform mat4 uProjection = mat4(1.f);
uniform mat4 uModel = mat4(1.f);
uniform mat4 uView = mat4(1.f);

uniform mat4 uOldProjView, uInvProjView, uCur2OldModel;


uniform bool uFar = false;
uniform bool uPlain = false;

out vec2 fUVs;

void main()
{
	vec4 position;
	fUVs = aUV;
	new2old = uOldProjView * uCur2OldModel * uInvProjView;

	if(uPlain)
		position = vec4(aPosition, 1.f);
	else
		position = uProjection * uView * uModel * vec4(aPosition, 1.f);

	if(uFar)
		gl_Position = position.xyww;
	else
		gl_Position = position;

	pixPosition = gl_Position;

}
