//Fragment Shader
#version 330 core
in vec2 fUVs;

layout(location = 0) out vec4 FragColor;

uniform sampler2D uColorTexture;
uniform sampler2D uBlurVec;

uniform float uDeltaT = 1.f;
uniform int uSamples = 15;
uniform bool uSymetric = true;

void main()
{
	
	vec4 preBlurVec = texture(uBlurVec, fUVs);

	if (preBlurVec.z <= 0.1f)
	{
		FragColor = texture(uColorTexture, fUVs);
		return;
	}

	vec3 result = texture(uColorTexture, fUVs).rgb;
	vec2 blurVec = preBlurVec.xy * uDeltaT * preBlurVec.z * preBlurVec.z / 10;


	if (uSymetric)
	{
		for (int i = 1; i <= uSamples; ++i)
		{
			result += texture(uColorTexture, fUVs + blurVec * (float(i) / uSamples)).rgb + texture(uColorTexture, fUVs - blurVec * (float(i) / uSamples)).rgb;
		}
		FragColor = vec4(result / (2 * uSamples + 1), 1.0);
	}
	else
	{
		for (int i = 1; i <= uSamples; ++i)
		{
			result += texture(uColorTexture, fUVs + blurVec * (float(i) / uSamples)).rgb;
		}
		FragColor = vec4(result / (uSamples + 1), 1.0);
	}

	//FragColor = vec4(vec3(preBlurVec.z), 1.f);
}