//Fragment Shader
#version 330 core
in vec2 fUVs;

layout(location = 0) out vec4 FragColor;

uniform sampler2D uColorTexture;
uniform sampler2D uBlurVec;

uniform float uDeltaT = 1.f;
uniform bool uSymetric = true;

uniform float weight[5] = float[](0.2270270270, 0.1945945946, 0.1216216216, 0.0540540541, 0.0162162162);
//uniform float weight[5] = float[](0.2222222222, 0.1111111111, 0.1111111111, 0.1111111111, 0.1111111111);


void main()
{
	vec4 preBlurVec = texture(uBlurVec, fUVs);

	if (preBlurVec.z == 0)
	{
		FragColor = texture(uColorTexture, fUVs);
		return;
	}

	vec3 result = texture(uColorTexture, fUVs).rgb * weight[0];
	vec2 blurVec = preBlurVec.xy * uDeltaT * preBlurVec.z * preBlurVec.z / 10;

	for (int i = 1; i <= 4; ++i)
	{
		result += texture(uColorTexture, fUVs + blurVec * (i / 4)).rgb *weight[i];
		if (uSymetric)
			result += texture(uColorTexture, fUVs - blurVec * (i / 4)).rgb *weight[i];
	}

	FragColor = vec4(result, 1.0);

	//FragColor = vec4(vec3(preBlurVec.z), 1.f);
}