//Fragment Shader
#version 330 core

in vec2 fUVs;

layout(location = 0) out vec4 BrightColor;

uniform sampler2D uColorTexture;
uniform vec3 uFilterColor = vec3(0.2126f, 0.7152f, 0.0722f);
uniform float uFilterThreshold = 1.f;

 
void main()
{
	vec4 FragColor = texture(uColorTexture, fUVs);

	float brightness = dot(FragColor.rgb, uFilterColor);

	if (brightness > uFilterThreshold)
		BrightColor = vec4(FragColor.rgb, 1.0);
	else
		BrightColor = vec4(0.);
}

