//Fragment Shader
#version 330
in vec3 eyePosition, worldNormal;
in vec2 fUVs;

//in vec3 fPosition;


layout(location = 0) out vec4 FragColor;

uniform sampler2D uColorTexture;
uniform sampler2DShadow uPointLightXP;
uniform vec4 material;					//vec4 in the form (ambient, point, directional, glossyness); so far it was (1, 1, 1, 3)

uniform vec3 LightColor;
uniform vec3 LightPosition;

float DirLightCalcShadowFactor(vec4 LightSpacePos)
{
	return textureProj(uPointLightXP, LightSpacePos);


	/*vec3 ProjCoords = LightSpacePos.xyz / LightSpacePos.w;
	vec2 UVCoords = vec2(0.5f * ProjCoords.x + 0.5f, 0.5f * ProjCoords.y + 0.5f);
	float z = 0.5f * ProjCoords.z + 0.5f;

	if (UVCoords.x < 0 || UVCoords.x > 1 || UVCoords.y < 0 || UVCoords.y > 1 || z < 0 || z > 1)
		return 1.0f;

	float Depth = texture(uPointLightXP, UVCoords).x;
	if (Depth < (z + 0.00001f))
		return 0.0f;
	else
		return 1.0f;*/
}
 
void main()
{
	float specularConst = material[3];
	vec4 uvColor = texture(uColorTexture, fUVs);

	vec3 cameraVec = normalize(eyePosition);
	vec3 worldPointLightDir = LightPosition - eyePosition;
	vec3 PointLightDirection = normalize(worldPointLightDir);

	float SpecularCosPoint = clamp(dot(cameraVec, normalize(reflect(PointLightDirection, worldNormal))), 0, 1);
	float cosThetaPoint1 = clamp(dot(worldNormal, PointLightDirection), 0, 1);

	float squaredist = worldPointLightDir.x * worldPointLightDir.x + worldPointLightDir.y * worldPointLightDir.y + worldPointLightDir.z * worldPointLightDir.z;


	FragColor = vec4(LightColor * material[1] * (cosThetaPoint1 + pow(SpecularCosPoint, specularConst)) / squaredist, uvColor.a);
	
	//FragColor = vec4((normalize(worldNormal)+1)/2, 1.0f);
	//FragColor = vec4(length(DirectionalLightDirection1) - 1.0f, length(DirectionalLightDirection1) - 1.0f, length(DirectionalLightDirection1) - 1.0f, 1.0f);

	//vec3 uvColor = texture(uColorTexture, fUVs).rgb;
	//FragColor = vec4(uvColor, 1.0);
	
	//vec3 uvColor = vec3(1.0 - (1.0 - texture(uPointLightXP, fUVs).x) * 25.0);
	//vec3 uvColor = vec3(texture(uPointLightXP, vec2(fPosition.x / 2 + 0.5f, fPosition.y / 2 + 0.5f)).x);
	//FragColor = vec4(uvColor, 1.0);
}