//Vertex Shader
#version 330 core

in vec3 aNormal, aPosition;
in vec2 aUV;

out vec3 eyePosition, worldNormal;
out vec2 fUVs;

//out vec3 fPosition;


//uniform vec3 PointLightPosition, DirectionalLightDirection1;
uniform mat4 uProjection, uView, uModel=mat4(1.f);


void main()
{
	fUVs = aUV;
	eyePosition = (uView * uModel * vec4(aPosition, 1.f)).xyz;
	mat3 scale = transpose(mat3(uModel))*mat3(uModel);
	vec3 Normal;
	for (int i = 0; i < 3; ++i)
		Normal[i] = 1/(scale[i][i])*aNormal[i];
	worldNormal = normalize((uView * uModel * vec4(Normal, 0.0f)).xyz);

	gl_Position = uProjection * vec4(eyePosition,1.f);


	//fPosition = aPosition;
	//gl_Position = vec4(aPosition, 1.0f);
}